import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "DU_81.DUInterface";
import "DU_81.Utilsx";
import "DU_81.Palantir";

oM=OptionsManager();

local pluginName = "Palantir III";
local pluginVersion = "v3.0";
-- modify as well Palantir.plugincompendium & Palantir.plugin



local displayWidth, displayHeight = Turbine.UI.Display.GetSize();
local windowWidth,windowHeight = oM.mWindow:GetSize();
local width = (displayWidth-windowWidth)/2;
local height = (displayHeight-windowHeight)/2;
oM.defaultOptionsMain.PositionX=width;
oM.defaultOptionsMain.PositionY=height;
player = Turbine.Gameplay.LocalPlayer.GetInstance();
local main={};
local color={};
local text={};
local dbb={};
local mez={};
local qslot={};

LocalPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
EffectList = LocalPlayer:GetEffects();	
-- Add and remove Calbacks functions
PalantirInCombatChanged = 		function(sender, args) 
	oM.mWindow.mzb.InCombatChanged(LocalPlayer:IsInCombat());	
end								
							
function InstallCallbacks()
DU_81.Utilsx.AddCallback(EffectList, "EffectAdded", PalantirEffectAddedCallback);
DU_81.Utilsx.AddCallback(EffectList, "EffectRemoved", PalantirEffectRemovedCallback);
DU_81.Utilsx.AddCallback(EffectList, "EffectCleared", PalantirEffectClearedCallback); -- May happend in death
DU_81.Utilsx.AddCallback(LocalPlayer, "InCombatChanged", PalantirInCombatChanged);
DU_81.Utilsx.AddCallback(Turbine.Chat, "Received", ParseMezText);

end

function UnloadPlugin()
	oM.mWindow.dbb.wqs:SetShortcut(nil);
	oM.mWindow.dbb.fqs:SetShortcut(nil);
	oM.mWindow.dbb.dqs:SetShortcut(nil);
	oM.mWindow.dbb.pqs:SetShortcut(nil);
	oM.mWindow.dbb.Refresh();   
	oM.SaveSettings();	
	
	--remove callbacks here
	if (PalantirEffectChangedCallback ~= nil) then
		DU_81.Utilsx.RemoveCallback(EffectList, "EffectAdded", PalantirEffectAddedCallback);
		DU_81.Utilsx.RemoveCallback(EffectList, "EffectRemoved", PalantirEffectRemovedCallback);
		DU_81.Utilsx.RemoveCallback(EffectList, "EffectCleared", PalantirEffectClearedCallback);
		DU_81.Utilsx.RemoveCallback(LocalPlayer, "InCombatChanged", PalantirInCombatChanged);  
		DU_81.Utilsx.RemoveCallback(Turbine.Chat, "Received", ParseMezText);
		PalantirEffectCAddedCallback = nil;    
		PalantirEffectRemovedCallback = nil;    
		PalantirEffectClearedCallback = nil;    
		PalantirInCombatChanged = nil;  
		ParseMezText = nil;  			
	end
end

-- Install callbacks once and Register once the unload function for the Palantir
window = Turbine.UI.Window();
window:SetWantsUpdates(true);
window.Update = function(sender,args)
	if (Plugins[pluginName] ~= nil) then
		Plugins[pluginName].Unload = function(self,sender,args)
										UnloadPlugin();
									end
		window:SetWantsUpdates(false);		
		InstallCallbacks();
	end
end       

function loadHandle()

end

function qsHandle()
	                 

end

function settingsDecode(t)
	local t2={};
	euroFormat=(tonumber("1,000")==1); -- will be true if the number is formatted with a comma for decimal place, false otherwise
	for k,v in pairs(t) do
		-- Needed to load English saved data with french Lotro, & viceversa
		if ((tonumber(v) == nil) and (type(v)=="string") and (string.find(v, "0x") == nil) and (string.find(v, "%d") == 1)) then 
			if euroFormat then 		
				v=tonumber((string.gsub(v, "%.", ",")));
			else
				v=tonumber((string.gsub(v, "%,", ".")));		
			end
		elseif(tonumber(v)~=nil and string.sub(v,1,2)~="0x")then
			v=tonumber(v);
		elseif (type(v)=="table")then
			v=settingsDecode(v);
		end
		t2[k]=v;
	end
	return t2
end

local tempLoad = Turbine.PluginData.Load(Turbine.DataScope.Account,"DU_81_Scope");
if(tempLoad~=nil)then
	tempLoad=settingsDecode(tempLoad);
	local scopeVal = tempLoad.Value;
	local scope="";
	if(scopeVal==1)then
		scope=Turbine.DataScope.Account;
	elseif(scopeVal==2)then
		scope=Turbine.DataScope.Character;
	else
		scope=Turbine.DataScope.Server
	end
	
	tempLoad = Turbine.PluginData.Load(scope,"DU_81_Main");
	if (tempLoad~=nil)then
		main  = settingsDecode(tempLoad);	
	else
		main  = oM.defaultOptionsMain;	
	end	
	tempLoad=Turbine.PluginData.Load(scope,"DU_81_Color");
	if (tempLoad~=nil)then
		color = settingsDecode(tempLoad);	
	else
		color = oM.defaultOptionsColor;
	end	
	tempLoad=Turbine.PluginData.Load(scope,"DU_81_Text");
	if (tempLoad~=nil)then
		text  = settingsDecode(tempLoad);	
	else
		text  = oM.defaultOptionsText;
	end	
	tempLoad=Turbine.PluginData.Load(scope,"DU_81_Dbb");
	if (tempLoad~=nil)then
		dbb   = settingsDecode(tempLoad);
	else
		dbb   = oM.defaultOptionsDbb;
	end		
	-- bad argument #1 to '?' (table expected, got nil) error if file doesn't exist
	tempLoad=Turbine.PluginData.Load(scope,"DU_81_Mez");
	if (tempLoad~=nil)then
		mez   = settingsDecode(tempLoad);	
	else
		mez   = oM.defaultOptionsMez;	
	end	
	oM.loadSettings(settingsDecode(main),settingsDecode(color),settingsDecode(text),settingsDecode(dbb),settingsDecode(mez));
	qslot = Turbine.PluginData.Load(Turbine.DataScope.Character,"DU_81_Quickslot");
	if(qslot ~= nil)then
		oM.AddShortcuts(settingsDecode(qslot));
	end	
else
	main  = oM.defaultOptionsMain;
	color = oM.defaultOptionsColor;
	text  = oM.defaultOptionsText;
	dbb   = oM.defaultOptionsDbb;
	mez   = oM.defaultOptionsMez;
	oM.loadSettings(main,color,text,dbb,mez);	

end	

-- Set [Show Options] button in Lotro plugin's manager
optionsPanel = Turbine.UI.Control();
--optionsPanel:SetBackColor( Turbine.UI.Color( 0.3, 0.3, 0.3 ) );
optionsPanel:SetSize( 600, 600 );
optionsButton=Turbine.UI.Lotro.Button();
optionsButton:SetSize(200,30);
optionsButton:SetText("Show Options");
optionsButton:SetParent(optionsPanel);
optionsButton.MouseClick=function(sender,args)
	if (oM.mWindow.holdSetup==false)then
			oM.sw.showSetup();
		else
			oM.mWindow.setupPending=true;
		end
end
if (plugin == nil)then
plugin = Turbine.UI.Control();

end
plugin.GetOptionsPanel = function( self )
  	return optionsPanel;
		
end
Turbine.Shell.WriteLine(pluginName.." "..pluginVersion.." by Loikki");
--[[
Turbine.Shell.WriteLine("P100: \195\100 \195\101 \195\102 \195\103 \195\104 \195\105 \195\106 \195\107 \195\108 \195\109 ");		
Turbine.Shell.WriteLine("P110: \195\110 \195\111 \195\112 \195\113 \195\114 \195\115 \195\116 \195\117 \195\118 \195\119 ");
Turbine.Shell.WriteLine("P120: \195\120 \195\121 \195\122 \195\123 \195\124 \195\125 \195\126 \195\127 \195\128 \195\129 ");		
Turbine.Shell.WriteLine("P130: \195\130 \195\131 \195\132 \195\133 \195\134 \195\135 \195\136 \195\137 \195\138 \195\139 ");
Turbine.Shell.WriteLine("P140: \195\140 \195\141 \195\142 \195\143 \195\144 \195\145 \195\146 \195\147 \195\148 \195\149 ");
Turbine.Shell.WriteLine("P150: \195\150 \195\151 \195\152 \195\153 \195\154 \195\155 \195\156 \195\157 \195\158 \195\159 ");
Turbine.Shell.WriteLine("P160: \195\160 \195\161 \195\162 \195\163 \195\164 \195\165 \195\166 \195\167 \195\168 \195\169 ");		
Turbine.Shell.WriteLine("P170: \195\170 \195\171 \195\172 \195\173 \195\174 \195\175 \195\176 \195\177 \195\178 \195\179 ");
Turbine.Shell.WriteLine("P180: \195\180 \195\181 \195\182 \195\183 \195\184 \195\185 \195\186 \195\187 \195\188 \195\189 ");		
Turbine.Shell.WriteLine("P190: \195\190 \195\191 \195\192 \195\193 \195\194 \195\195 \195\196 \195\197 \195\198 \195\199 ");
Turbine.Shell.WriteLine("P200: \195\200 \195\201 \195\202 \195\203 \195\204 \195\205 \195\206 \195\207 \195\208 \195\209 ");
Turbine.Shell.WriteLine("P210: \195\210 \195\211 \195\212 \195\213 \195\214 \195\215 \195\216 \195\217 \195\218 \195\219 ");
Turbine.Shell.WriteLine("P220: \195\220 \195\221 \195\222 \195\223 \195\224 \195\225 \195\226 \195\227 \195\228 \195\229 ");
	]]--
-- Turbine.Shell.WriteLine("Palantir test 1");
